VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Befragung 
   Caption         =   "Form1"
   ClientHeight    =   4935
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   8115
   LinkTopic       =   "Form1"
   ScaleHeight     =   4935
   ScaleWidth      =   8115
   StartUpPosition =   3  'Windows-Standard
   Begin MSComDlg.CommonDialog dlgdialog 
      Left            =   5400
      Top             =   720
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSFlexGridLib.MSFlexGrid grd_Befragung 
      Height          =   3375
      Left            =   480
      TabIndex        =   0
      Top             =   1320
      Width           =   7335
      _ExtentX        =   12938
      _ExtentY        =   5953
      _Version        =   393216
      AllowUserResizing=   3
   End
   Begin VB.Label lbl_Ueberschrift 
      Caption         =   "lbl_Ueberschrift"
      Height          =   495
      Left            =   480
      TabIndex        =   2
      Top             =   0
      Width           =   4455
   End
   Begin VB.Label lbl_Untersuchung 
      Caption         =   "lbl_Untersuchung"
      Height          =   495
      Left            =   480
      TabIndex        =   1
      Top             =   720
      Width           =   4335
   End
   Begin VB.Menu mnu_datei 
      Caption         =   "&Datei"
      Begin VB.Menu mnu_datei_laden 
         Caption         =   "L&aden"
      End
      Begin VB.Menu mnu_datei_loeschen 
         Caption         =   "&Lschen"
      End
      Begin VB.Menu mnu_datei_ende 
         Caption         =   "&Ende"
      End
   End
   Begin VB.Menu mnu_info 
      Caption         =   "&Info"
   End
End
Attribute VB_Name = "Befragung"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type Datensatz
    Nr As Integer
    Text As String * 40
    Anzahl As Integer
    Prozent As Double
End Type

Dim Befragungstext As String

Dim Datensaetze(50) As Datensatz
Dim Anzahl_der_Auswahl As Integer
Dim Summe As Double

    
Private Sub Form_Load()
    lbl_Untersuchung.Caption = ""
    lbl_Untersuchung.FontBold = True
    lbl_Untersuchung.FontSize = 12
    
    lbl_Ueberschrift.Caption = "Auswertung der Befragung"
    lbl_Ueberschrift.FontBold = True
    lbl_Ueberschrift.FontSize = 12
    
    grd_Befragung.Rows = 1
    grd_Befragung.Cols = 4
    grd_Befragung.AllowUserResizing = flexResizeColumns
    ' der Nutzer kann die Breite der Zellen mit der Maus anpassen
    mnu_datei_laden.Enabled = True
    mnu_datei_loeschen.Enabled = False
    
End Sub

Private Sub mnu_datei_ende_Click()
    Unload Me
End Sub

Private Sub mnu_datei_laden_Click()
    Datei_laden
    mnu_datei_laden.Enabled = False
    Datei_auswerten
    Grid_fuellen
    mnu_datei_loeschen.Enabled = True
End Sub

Private Sub Grid_fuellen()
    Dim Zaehler As Integer
    
    grd_Befragung.TextMatrix(0, 0) = "Nr"
    grd_Befragung.TextMatrix(0, 1) = "Bezeichnung"
    grd_Befragung.TextMatrix(0, 2) = "Anzahl"
    grd_Befragung.TextMatrix(0, 3) = "Prozent"
    For Zaehler = 0 To Anzahl_der_Auswahl - 1
        grd_Befragung.AddItem ""
        grd_Befragung.TextMatrix(Zaehler + 1, 0) = Datensaetze(Zaehler).Nr
        grd_Befragung.TextMatrix(Zaehler + 1, 1) = Datensaetze(Zaehler).Text
        grd_Befragung.TextMatrix(Zaehler + 1, 2) = Datensaetze(Zaehler).Anzahl
        grd_Befragung.TextMatrix(Zaehler + 1, 3) = Format(Datensaetze(Zaehler).Prozent, "###.##")
    Next Zaehler
    grd_Befragung.FixedRows = 1
End Sub

Private Sub Datei_auswerten()
    Dim Zaehler As Integer
    
    For Zaehler = 0 To Anzahl_der_Auswahl - 1
        Datensaetze(Zaehler).Prozent = Datensaetze(Zaehler).Anzahl * 100 / Summe
    Next Zaehler
End Sub

Private Sub Datei_laden()
    Dim dateiname As String
    
    Dim Zaehler As Integer
    Dim Wert As Integer
    
    dlgdialog.Flags = cdlOFNOverwritePrompt
    dlgdialog.Filter = "txt| *.txt"
    dlgdialog.filename = ""
    dlgdialog.ShowOpen
    
    dateiname = dlgdialog.filename
    If dateiname <> "" Then
        Open dateiname For Input As #1
        Input #1, Befragungstext
        lbl_Untersuchung = Befragungstext
        Input #1, Anzahl_der_Auswahl
        For Zaehler = 0 To Anzahl_der_Auswahl - 1
            Datensaetze(Zaehler).Nr = Zaehler + 1
            Input #1, Datensaetze(Zaehler).Text
        Next Zaehler
        Summe = 0
        While Not EOF(1)
            Input #1, Wert
            If Wert >= 1 And Wert <= Anzahl_der_Auswahl Then
               Datensaetze(Wert - 1).Anzahl = Datensaetze(Wert - 1).Anzahl + 1
               Summe = Summe + 1
               End If
        Wend
        Close #1
      Else
        MsgBox "Sie haben keine gltige Datei gewhlt"
    End If

End Sub

Private Sub mnu_datei_loeschen_Click()
    Dim Zaehler As Integer
    
    grd_Befragung.Rows = 1
    grd_Befragung.Cols = 4
    'grd_Befragung.FixedRows = 0
    grd_Befragung.Clear
    
    'For Zaehler = (Anzahl_der_Auswahl - 1) To 0 Step -1
    '    grd_Befragung.RemoveItem (Zaehler)
    'Next Zaehler
    grd_Befragung.TextMatrix(0, 0) = ""
    grd_Befragung.TextMatrix(0, 1) = ""
    grd_Befragung.TextMatrix(0, 2) = ""
    grd_Befragung.TextMatrix(0, 3) = ""

    Erase Datensaetze
                
    mnu_datei_laden.Enabled = True
    mnu_datei_loeschen.Enabled = False
    
    lbl_Untersuchung = ""
End Sub

Private Sub mnu_info_Click()
    MsgBox "Ein Programm von Joachim Rhl"
End Sub
